<?php
namespace Claromentis\Search;

$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_f73dab6066" . "30b388645c4" . "f7d3fbb13bb" => base64_decode("YXJyYXlf" . "bWVyZ2U="), "_c8d1809bdc783b969816" . "5309fe704327" => base64_decode("VGhlIHNlY29uZCBwYXJhbWV0" . "ZXIgb2Yg"), "_8f7dd777fd" . "eec4a63087b" . "ff8b5c757bf" => base64_decode("VW5zdXBwb3J0ZWQgb2JqZW" . "N0IHR5cGUgLSA="), "_5306cb5e8985434a2a638b90f897" . "940d" => base64_decode("IGlzIG5vdCBj" . "YWxsYWJsZQ=="), "_075c6c4172" . "eaf58cfa848" . "28a3582d19a" => base64_decode("YXJyYXlf" . "dW5pcXVl"), "_d706c160e45bf743" . "4fff82a5976f0e19" => base64_decode("YXJyYX" . "lfa2V5" . "cw=="), "_bd71c3b5c201fc11db82ed14ce42" . "4de5" => base64_decode("aW5fY" . "XJyYX" . "k="), "_6fd29f1ce82d" . "5e2d09a2d806c" . "2e2b1d5" => base64_decode("aXNfY2FsbG" . "FibGU="));
use Claromentis\Search\Application\CacheableInterface;
use Claromentis\Search\Exception\UnsupportedItemTypeException;
use ErrorHandler;
use Exception;
use Claromentis\Search\Indexing\Exception\IndexingException;




class ItemTypeFactory extends ErrorHandler
{
    
    
    
    
    protected $search_item_types = [];
    
    
    
    
    protected $indexing_types = [];
    
    
    
    
    protected $cacheable_item_types = [];
    
    
    
    
    
    
    public function __construct()
    {
        $_a56d3cb9419f5f513e6d57bbcaaf3397 = new Config\Applications();
        $_f3e72c5e54a6dd0fb5c5005cd9574e42 = $_a56d3cb9419f5f513e6d57bbcaaf3397->GetAll();
        foreach ($_f3e72c5e54a6dd0fb5c5005cd9574e42 as $_f44467aacb8a4520c7382769d24aa422) {
            $this->RegisterApplication($_f44467aacb8a4520c7382769d24aa422);
        }
        \ClaPlugins::I()->RegisterIndexingObjectType($this);
    }
    
    
    
    
    
    
    public function RegisterApplication(Application\ApplicationInterface $_f44467aacb8a4520c7382769d24aa422)
    {
        $_17728688d370dbb69c53d9e641c4b0e0 = $_f44467aacb8a4520c7382769d24aa422->GetTypes();
        foreach ($_17728688d370dbb69c53d9e641c4b0e0 as $type => $_ef7e3c851590d142b4d780e7b9043897) {
            $this->RegisterType($type, $_ef7e3c851590d142b4d780e7b9043897);
        }
        if ($_f44467aacb8a4520c7382769d24aa422 instanceof CacheableInterface) {
            $_a18bef7ab1ad0a4c0171b3201caa8064 = $_f44467aacb8a4520c7382769d24aa422->getCacheableTypes();
            foreach ($_a18bef7ab1ad0a4c0171b3201caa8064 as $type) {
                $this->RegisterCacheableType($type);
            }
        }
    }
    
    
    
    
    
    
    
    public function RegisterType($type, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_6fd29f1ce82d5e2d09a2" . "d806c2e2b1d5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_c8d1809bdc783b9698165309fe7043" . "27"] . __METHOD__ . $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_5306cb5e898" . "5434a2a638b9" . "0f897940d"], 1);
        }
        $this->search_item_types[$type] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    public function RegisterCacheableType($type)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_bd71c3b5c201fc11db82ed" . "14ce424de5"]($type, $this->cacheable_item_types)) {
            $this->cacheable_item_types[] = $type;
        }
    }
    
    
    
    
    
    
    
    public function Get($type)
    {
        if (isset($this->search_item_types[$type])) {
            return $this->search_item_types[$type]();
        } else {
            $e = new UnsupportedItemTypeException($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_8f7dd77" . "7fdeec4a" . "63087bff" . "8b5c757b" . "f"] . $type);
            $e->item_type = $type;
            throw $e;
        }
    }
    
    
    
    
    
    
    public function GetAllIndexingTypes()
    {
        return $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_075c6c41" . "72eaf58cf" . "a84828a35" . "82d19a"]($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_f73dab60" . "6630b3886" . "45c4f7d3f" . "bb13bb"]($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_d706c160e4" . "5bf7434fff8" . "2a5976f0e19"]($this->search_item_types), $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_d706c160e45bf7434fff82a" . "5976f0e19"]($this->indexing_types)));
    }
    
    
    
    
    
    
    public function GetCacheableIndexingTypes() : array
    {
        return $this->cacheable_item_types;
    }
    
    
    
    
    
    
    
    public function RegisterIndexingType($_90a9b1825557bb7e0aff3dc1a7962296, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_6fd29f1ce82d5e2d09a2d806c2e2b1" . "d5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_c8d1809bdc783b9698165309fe7043" . "27"] . __METHOD__ . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_5306cb5e8985434a2a638b90f8" . "97940d"], 1);
        }
        $this->indexing_types[$_90a9b1825557bb7e0aff3dc1a7962296] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    public function GetIndexingObject($type)
    {
        if (isset($this->indexing_types[$type])) {
            $_68ffaaa31e3ba49ed9d6159fbee9f043 = $this->indexing_types[$type]();
            return $_68ffaaa31e3ba49ed9d6159fbee9f043;
        } else {
            return $this->Get($type)->GetIndexingObject();
        }
    }
}